Loading...
Searching...
No Matches
casacore::TempImage< T > Class Template Reference
images package (libcasa_images) » Images_module

More...

`#include <TempImage.h>`

## Public Member Functions

| TempImage ()
| The default constructor creates an empty image.
| TempImage (const TiledShape &mapShape, const CoordinateSystem &coordinateInfo, Int maxMemoryInMB=-1)
| Construct a temporary Image from shape and coordinate information.
| TempImage (const TiledShape &mapShape, const CoordinateSystem &coordinateInfo, Double maxMemoryInMB)
| TempImage (const TempImage< T > &other)
| Copy constructor (reference semantics).
| ~TempImage ()
| Destructor.
TempImage< T > & | operator= (const TempImage< T > &other)
| Assignment operator (reference semantics).
virtual ImageInterface< T > * | cloneII () const
| Make a copy of the object (reference semantics).
virtual String | imageType () const
| Get the image type (returns name of derived class).
virtual Bool | isPaged () const
| Is the TempImage paged to disk?
virtual Bool | canReferenceArray () const
| Can the lattice data be referenced as an array section?
virtual Bool | isWritable () const
| Is the TempImage writable?
virtual void | setDefaultMask (const String &maskName)
| Set the default pixelmask to the mask with the given name (which has to exist in the "masks" group).
void | removeMask ()
| Delete the pixel mask attached to the TempImage.
virtual void | useMask (MaskSpecifier=MaskSpecifier())
| Use the mask as specified.
virtual void | removeRegion (const String &name, RegionHandler::GroupType=RegionHandler::Any, Bool throwIfUnknown=True)
| Remove a region/mask belonging to the image from the given group (which can be Any).
virtual void | attachMask (const Lattice< Bool > &mask)
| Attach a mask to the TempImage.
virtual Bool | isMasked () const
| It a mask attached to the image?
virtual Bool | hasPixelMask () const
| Does the image object use a pixelmask?
virtual const Lattice< Bool > & | pixelMask () const
| Get access to the pixelmask used.
virtual Lattice< Bool > & | pixelMask ()
virtual Bool | doGetMaskSlice (Array< Bool > &buffer, const Slicer &section)
| Get a section of the mask.
virtual void | flush ()
| Flush the data.
virtual void | tempClose ()
| Close the TempImage temporarily (if it is paged to disk).
virtual void | reopen ()
| If needed, reopen a temporarily closed TempLattice.
virtual void | resize (const TiledShape &newShape)
| Function which changes the shape of the image (N.B.
virtual String | name (Bool stripPath=False) const
| Return the name of the current TempImage object.
virtual IPosition | shape () const
| Return the shape of the image.
virtual void | set (const T &value)
| Function which sets all of the elements in the Lattice to a value.
virtual void | apply (T(*function)(T))
| Replace every element, x, of the lattice with the result of f(x).
virtual void | apply (T(*function)(const T &))
virtual void | apply (const Functional< T, T > &function)
virtual T | getAt (const IPosition &where) const
| Get or put a single pixel.
virtual void | putAt (const T &value, const IPosition &where)
| Put the value of a single element.
virtual LatticeIterInterface< T > * | makeIter (const LatticeNavigator &navigator, Bool useRef) const
| This is the implementations of the letters for the envelope Iterator class Note: Not for public use .
virtual uInt | advisedMaxPixels () const
| Returns the maximum recommended number of pixels for a cursor.
virtual IPosition | doNiceCursorShape (uInt maxPixels) const
| Help the user pick a cursor for most efficient access.
virtual uInt | maximumCacheSize () const
| Maximum size - not necessarily all used.
virtual void | setMaximumCacheSize (uInt howManyPixels)
| Set the maximum (allowed) cache size as indicated.
virtual void | setCacheSizeFromPath (const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath)
| Set the cache size as to "fit" the indicated path.
virtual void | setCacheSizeInTiles (uInt howManyTiles)
| Set the actual cache size for this Array to be be big enough for the indicated number of tiles.
virtual void | clearCache ()
| Clears and frees up the caches, but the maximum allowed cache size is unchanged from when setCacheSize was called.
virtual void | showCacheStatistics (ostream &os) const
| Report on cache success.
virtual Bool | ok () const
| Check for symmetry in data members.
Public Member Functions inherited from casacore::ImageInterface< T >
| ImageInterface ()
| ImageInterface (const RegionHandler &regionHandler)
| Construct for a specific region handler object.
| ImageInterface (const ImageInterface &other)
| Copy constructor (copy semantics).
virtual | ~ImageInterface ()
virtual MaskedLattice< T > * | cloneML () const
| Make a copy of the derived object (reference semantics).
virtual Bool | setUnits (const Unit &newUnits)
| Function which get and set the units associated with the image pixels (i.e.
virtual const Unit & | units () const
virtual Bool | setCoordinateInfo (const CoordinateSystem &coords)
| Functions to set or replace the coordinate information in the Image Returns False on failure, e.g.
const CoordinateSystem & | coordinates () const
virtual LELCoordinates | lelCoordinates () const
| Function to get a LELCoordinate object containing the coordinates.
LoggerHolder & | logger ()
| Get access to the LoggerHolder.
const LoggerHolder & | logger () const
LogIO & | logSink ()
| Allow messages to be logged to this ImageInterface.
const LogIO & | logSink () const
void | appendLog (const LoggerHolder &other)
| Add the messages from the other image logger to this one.
const TableRecord & | miscInfo () const
| Often we have miscellaneous information we want to attach to an image.
virtual Bool | setMiscInfo (const RecordInterface &newInfo)
const ImageInfo & | imageInfo () const
| The ImageInfo object contains some miscellaneous information about the image which unlike that stored in MiscInfo, has a standard list of things, such as the restoring beam.
ImageInfo & | rwImageInfo ()
| Get non-const access to the ImageInfo.
virtual Bool | setImageInfo (const ImageInfo &info)
virtual ImageAttrHandler & | attrHandler (Bool createHandler=False)
| Get access to the attribute handler.
ImageAttrHandler & | roAttrHandler () const
Bool | canDefineRegion () const
| Can the image handle region definition?
virtual ImageRegion | makeMask (const String &name, Bool defineAsRegion=True, Bool setAsDefaultMask=True, Bool initialize=False, Bool value=True)
| Make a mask which is suitable for the type of image.
virtual void | defineRegion (const String &name, const ImageRegion &region, RegionHandler::GroupType, Bool overwrite=False)
| Define a region/mask belonging to the image.
virtual Bool | hasRegion (const String &regionName, RegionHandler::GroupType=RegionHandler::Any) const
| Does the image have a region with the given name?
virtual ImageRegion * | getImageRegionPtr (const String &name, RegionHandler::GroupType=RegionHandler::Any, Bool throwIfUnknown=True) const
| Get a region/mask belonging to the image from the given group (which can be Any).
virtual void | renameRegion (const String &newName, const String &oldName, RegionHandler::GroupType=RegionHandler::Any, Bool overwrite=False)
| Rename a region.
virtual Vector< String > | regionNames (RegionHandler::GroupType=RegionHandler::Any) const
| Get the names of all regions/masks.
virtual String | getDefaultMask () const
| Get the name of the default pixelmask.
ImageRegion | getRegion (const String &regionName, RegionHandler::GroupType=RegionHandler::Any) const
| Get a region belonging to the image.
String | makeUniqueRegionName (const String &rootName, uInt startNumber=1) const
| Make a unique region name from the given root name, thus make it such that the name is not already in use for a region or mask.
Bool | toRecord (String &error, RecordInterface &outRec)
| Save and restore an ImageInterface object to or from a state Record.
Bool | fromRecord (String &error, const RecordInterface &inRec)
Public Member Functions inherited from casacore::MaskedLattice< T >
| MaskedLattice ()
| Default constructor.
| MaskedLattice (const MaskedLattice< T > &)
| Copy constructor.
virtual | ~MaskedLattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual Lattice< T > * | clone () const
| Make a copy of the derived object (reference semantics).
const LatticeRegion & | region () const
| Get the region used.
Bool | getMask (COWPtr< Array< Bool > > &buffer, Bool removeDegenerateAxes=False) const
| Get the mask or a slice from the mask.
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Bool | getMask (Array< Bool > &buffer, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const Slicer &section, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False)
Array< Bool > | getMask (Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const Slicer &section, Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Public Member Functions inherited from casacore::Lattice< T >
virtual | ~Lattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual DataType | dataType () const
| Get the data type of the lattice.
T | operator() (const IPosition &where) const
| Return the value of the single element located at the argument IPosition.
Bool | get (COWPtr< Array< T > > &buffer, Bool removeDegenerateAxes=False) const
| Functions which extract an Array of values from a Lattice.
Bool | getSlice (COWPtr< Array< T > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
Bool | getSlice (COWPtr< Array< T > > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Bool | getSlice (COWPtr< Array< T > > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Bool | get (Array< T > &buffer, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const Slicer &section, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False)
Array< T > | get (Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const Slicer &section, Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
void | putSlice (const Array< T > &sourceBuffer, const IPosition &where, const IPosition &stride)
| A function which places an Array of values within this instance of the Lattice at the location specified by the IPosition "where", incrementing by "stride".
void | putSlice (const Array< T > &sourceBuffer, const IPosition &where)
void | put (const Array< T > &sourceBuffer)
void | operator+= (const Lattice< T > &other)
| Add, subtract, multiple, or divide by another Lattice.
void | operator-= (const Lattice< T > &other)
void | operator*= (const Lattice< T > &other)
void | operator/= (const Lattice< T > &other)
virtual void | copyData (const Lattice< T > &from)
| Copy the data from the given lattice to this one.
virtual void | copyDataTo (Lattice< T > &to) const
| Copy the data from this lattice to the given lattice.
Public Member Functions inherited from casacore::LatticeBase
virtual | ~LatticeBase ()
| A virtual destructor is needed so that it will use the actual destructor in the derived class.
virtual Bool | isPersistent () const
| Is the lattice persistent and can it be loaded by other processes as well?
virtual void | save (const String &fileName) const
| Save the image in an AipsIO file with the given name.
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| It is strongly recommended to use class LatticeLocker to handle lattice locking.
virtual void | unlock ()
virtual Bool | hasLock (FileLocker::LockType) const
virtual void | resync ()
| Resynchronize the Lattice object with the lattice file.
virtual uInt | ndim () const
| Return the number of axes in this Lattice.
virtual size_t | nelements () const
| Return the total number of elements in this Lattice.
size_t | size () const
Bool | conform (const LatticeBase &other) const
| Return a value of "True" if this instance of Lattice and 'other' have the same shape, otherwise returns a value of "False".
IPosition | niceCursorShape (uInt maxPixels) const
| Returns a recommended cursor shape for iterating through all the pixels in the Lattice.
IPosition | niceCursorShape () const

## Protected Member Functions

virtual const LatticeRegion * | getRegionPtr () const
| Get the region used (it always returns 0).
virtual Bool | doGetSlice (Array< T > &buffer, const Slicer &theSlice)
| Function which extracts an array from the map.
virtual void | doPutSlice (const Array< T > &sourceBuffer, const IPosition &where, const IPosition &stride)
| Function to replace the values in the map with soureBuffer.
Protected Member Functions inherited from casacore::ImageInterface< T >
ImageInterface & | operator= (const ImageInterface &other)
| Assignment (copy semantics) is only useful for derived classes.
Bool | restoreImageInfo (const RecordInterface &rec)
| Restore the image info from the record.
void | setLogMember (const LoggerHolder &logger)
| Set the image logger variable.
void | setImageInfoMember (const ImageInfo &imageInfo)
| Set the image info variable.
void | setCoordsMember (const CoordinateSystem &coords)
| Set the coordinate system variable.
void | setUnitMember (const Unit &unit)
| Set the unit variable.
void | setMiscInfoMember (const RecordInterface &rec)
| Set the miscinfo variable.
RegionHandler * | getRegionHandler ()
| Get access to the region handler.
Protected Member Functions inherited from casacore::MaskedLattice< T >
MaskedLattice< T > & | operator= (const MaskedLattice< T > &)
| Assignment can only be used by derived classes.
Protected Member Functions inherited from casacore::Lattice< T >
| Lattice ()
| Define default constructor to satisfy compiler.
virtual void | handleMath (const Lattice< T > &from, int oper)
| Handle the Math operators (+=, -=, *=, /=).
virtual void | handleMathTo (Lattice< T > &to, int oper) const
| Lattice (const Lattice< T > &)
| Copy constructor and assignment can only be used by derived classes.
Lattice< T > & | operator= (const Lattice< T > &)
void | handleMathTo (Lattice< Bool > &, int) const
Protected Member Functions inherited from casacore::LatticeBase
| LatticeBase ()
| Define default constructor to be used by derived classes.
| LatticeBase (const LatticeBase &)
| Copy constructor and assignment can only be used by derived classes.
LatticeBase & | operator= (const LatticeBase &)
void | throwBoolMath () const
| Throw an exception for arithmetic on a Bool Lattice.

## Private Member Functions

void | applyMaskSpecifier (const MaskSpecifier &)
void | applyMask (const String &maskName)

## Private Attributes

TempLattice< T > * | mapPtr_p
Lattice< Bool > * | maskPtr_p

## Detailed Description

template<class T>
class casacore::TempImage< T >

Temporary astronomical images.

### Intended use:

Public interface

### Review Status

Test programs:
  tTempImage

### Prerequisite

- CoordinateSystem
- ImageInterface
- TempLattice

### Etymology

The TempImage name comes from its role as the Image class for temporary storage.

### Synopsis

The class TempImage is useful for storing temporary images for which it is not known whether they can be held in memory. It uses class TempLattice to hold the image in memory when it is small enough. Otherwise it is held in a temporary file. Similarly to TempLattice one can give the maximum memory to use to control when the image can be held in memory.
The other Image information like coordinates, units, and miscinfo is held in member variables and disappears when the TempImage object is destructed.

It is possibly to temporarily close a TempImage, which only takes effect when it is created as a PagedArray. In this way it is possible to reduce the number of open files in case a lot of TempImage objects are used. A temporarily closed TempImage will be reopened automatically when needed. It can also be reopened explicitly.

### Example

### Motivation

The size of astronomical data can be very large. The ability to fit an entire image into random access memory cannot be guaranteed. Paging from disk pieces of the image appeared to be the way to deal with this problem.

Definition at line 95 of file TempImage.h.

## Constructor & Destructor Documentation

## TempImage() [1/4]

template<class T>

casacore::TempImage< T >::TempImage | ( |  | ) |

The default constructor creates an empty image.

Referenced by operator=(), and TempImage().

## TempImage() [2/4]

template<class T>

casacore::TempImage< T >::TempImage | ( | const TiledShape & | mapShape,
|  | const CoordinateSystem & | coordinateInfo,
|  | Int | maxMemoryInMB = -1 )

Construct a temporary Image from shape and coordinate information.

If the image is sufficiently small, it is kept in memory. Otherwise it is kept in a temporary disk table. It can be forced to disk by setting maxMemoryinMB=0. The algorithm is the same as in class TempLattice.

## TempImage() [3/4]

template<class T>

casacore::TempImage< T >::TempImage | ( | const TiledShape & | mapShape,
|  | const CoordinateSystem & | coordinateInfo,
|  | Double | maxMemoryInMB )

## TempImage() [4/4]

template<class T>

casacore::TempImage< T >::TempImage | ( | const TempImage< T > & | other | ) |

Copy constructor (reference semantics).

References TempImage().

## ~TempImage()

template<class T>

casacore::TempImage< T >::~TempImage | ( |  | ) |

Destructor.

## Member Function Documentation

## advisedMaxPixels()

template<class T>

virtual uInt casacore::TempImage< T >::advisedMaxPixels | ( |  | ) | const

virtual

Returns the maximum recommended number of pixels for a cursor.

This is the number of pixels in a tile.

Reimplemented from casacore::Lattice< T >.

## apply() [1/3]

template<class T>

virtual void casacore::TempImage< T >::apply | ( | const Functional< T, T > & | function | ) |

virtual

Reimplemented from casacore::Lattice< T >.

## apply() [2/3]

template<class T>

virtual void casacore::TempImage< T >::apply | ( | T(* | function )(const T &) | ) |

virtual

Reimplemented from casacore::Lattice< T >.

## apply() [3/3]

template<class T>

virtual void casacore::TempImage< T >::apply | ( | T(* | function )(T) | ) |

virtual

Replace every element, x, of the lattice with the result of f(x).

You must pass in the address of the function – so the function must be declared and defined in the scope of your program.
Both versions of apply require a function that accepts a single argument of type T (the Lattice template actual type) and returns a result of the same type. The first apply expects a function with an argument passed by value; the second expects the argument to be passed by const reference. The first form ought to run faster for the built-in types, which may be an issue for large images stored in memory, where disk access is not an issue.

Reimplemented from casacore::Lattice< T >.

## applyMask()

template<class T>

void casacore::TempImage< T >::applyMask | ( | const String & | maskName | ) |

private

## applyMaskSpecifier()

template<class T>

void casacore::TempImage< T >::applyMaskSpecifier | ( | const MaskSpecifier & |  | ) |

private

## attachMask()

template<class T>

virtual void casacore::TempImage< T >::attachMask | ( | const Lattice< Bool > & | mask | ) |

virtual

Attach a mask to the TempImage.

It replaces a probably already attached mask. It has to have the same shape as the image.

References casacore::mask().

## canReferenceArray()

template<class T>

virtual Bool casacore::TempImage< T >::canReferenceArray | ( |  | ) | const

virtual

Can the lattice data be referenced as an array section?

Reimplemented from casacore::LatticeBase.

## clearCache()

template<class T>

virtual void casacore::TempImage< T >::clearCache | ( |  | ) |

virtual

Clears and frees up the caches, but the maximum allowed cache size is unchanged from when setCacheSize was called.

Reimplemented from casacore::LatticeBase.

## cloneII()

template<class T>

virtual ImageInterface< T > * casacore::TempImage< T >::cloneII | ( |  | ) | const

virtual

Make a copy of the object (reference semantics).

Implements casacore::ImageInterface< T >.

References casacore::ImageInterface< T >::ImageInterface().

## doGetMaskSlice()

template<class T>

virtual Bool casacore::TempImage< T >::doGetMaskSlice | ( | Array< Bool > & | buffer,
|  | const Slicer & | section )

virtual

Get a section of the mask.

It throws an exception if there is no mask.

Reimplemented from casacore::MaskedLattice< T >.

## doGetSlice()

template<class T>

virtual Bool casacore::TempImage< T >::doGetSlice | ( | Array< T > & | buffer,
|  | const Slicer & | theSlice )

protected virtual

Function which extracts an array from the map.

Implements casacore::Lattice< T >.

## doNiceCursorShape()

template<class T>

virtual IPosition casacore::TempImage< T >::doNiceCursorShape | ( | uInt | maxPixels | ) | const

virtual

Help the user pick a cursor for most efficient access.

Reimplemented from casacore::LatticeBase.

## doPutSlice()

template<class T>

virtual void casacore::TempImage< T >::doPutSlice | ( | const Array< T > & | sourceBuffer,
|  | const IPosition & | where,
|  | const IPosition & | stride )

protected virtual

Function to replace the values in the map with soureBuffer.

Implements casacore::Lattice< T >.

## flush()

template<class T>

virtual void casacore::TempImage< T >::flush | ( |  | ) |

virtual

Flush the data.

Reimplemented from casacore::LatticeBase.

## getAt()

template<class T>

virtual T casacore::TempImage< T >::getAt | ( | const IPosition & | where | ) | const

virtual

Get or put a single pixel.

Note that the function operator () can also be used to get a pixel.

Reimplemented from casacore::Lattice< T >.

## getRegionPtr()

template<class T>

virtual const LatticeRegion * casacore::TempImage< T >::getRegionPtr | ( |  | ) | const

protected virtual

Get the region used (it always returns 0).

Implements casacore::MaskedLattice< T >.

## hasPixelMask()

template<class T>

virtual Bool casacore::TempImage< T >::hasPixelMask | ( |  | ) | const

virtual

Does the image object use a pixelmask?

This is similar to isMasked().

Reimplemented from casacore::MaskedLattice< T >.

## imageType()

template<class T>

virtual String casacore::TempImage< T >::imageType | ( |  | ) | const

virtual

Get the image type (returns name of derived class).

Implements casacore::ImageInterface< T >.

## isMasked()

template<class T>

virtual Bool casacore::TempImage< T >::isMasked | ( |  | ) | const

virtual

It a mask attached to the image?

Reimplemented from casacore::MaskedLattice< T >.

## isPaged()

template<class T>

virtual Bool casacore::TempImage< T >::isPaged | ( |  | ) | const

virtual

Is the TempImage paged to disk?

Reimplemented from casacore::LatticeBase.

## isWritable()

template<class T>

virtual Bool casacore::TempImage< T >::isWritable | ( |  | ) | const

virtual

Is the TempImage writable?

Reimplemented from casacore::LatticeBase.

## makeIter()

template<class T>

virtual LatticeIterInterface< T > * casacore::TempImage< T >::makeIter | ( | const LatticeNavigator & | navigator,
|  | Bool | useRef ) const

virtual

This is the implementations of the letters for the envelope Iterator class
Note: Not for public use
.

Reimplemented from casacore::Lattice< T >.

## maximumCacheSize()

template<class T>

virtual uInt casacore::TempImage< T >::maximumCacheSize | ( |  | ) | const

virtual

Maximum size - not necessarily all used.

In pixels.

Reimplemented from casacore::LatticeBase.

## name()

template<class T>

virtual String casacore::TempImage< T >::name | ( | Bool | stripPath = False | ) | const

virtual

Return the name of the current TempImage object.

It is always "Temporary_Image"

Implements casacore::ImageInterface< T >.

References casacore::False.

Referenced by removeRegion().

## ok()

template<class T>

virtual Bool casacore::TempImage< T >::ok | ( |  | ) | const

virtual

Check for symmetry in data members.

Implements casacore::ImageInterface< T >.

## operator=()

template<class T>

TempImage< T > & casacore::TempImage< T >::operator= | ( | const TempImage< T > & | other | ) |

Assignment operator (reference semantics).

References TempImage().

## pixelMask() [1/2]

template<class T>

virtual Lattice< Bool > & casacore::TempImage< T >::pixelMask | ( |  | ) |

virtual

Reimplemented from casacore::MaskedLattice< T >.

## pixelMask() [2/2]

template<class T>

virtual const Lattice< Bool > & casacore::TempImage< T >::pixelMask | ( |  | ) | const

virtual

Get access to the pixelmask used.

An exception is thrown if the image does not use a pixelmask.

Reimplemented from casacore::MaskedLattice< T >.

## putAt()

template<class T>

virtual void casacore::TempImage< T >::putAt | ( | const T & | value,
|  | const IPosition & | where )

virtual

Put the value of a single element.

The default implementation uses putSlice.

Reimplemented from casacore::Lattice< T >.

References casacore::NewDelAllocator< T >::value.

## removeMask()

template<class T>

void casacore::TempImage< T >::removeMask | ( |  | ) |

inline

Delete the pixel mask attached to the TempImage.

Does nothing if there isn't one

Definition at line 149 of file TempImage.h.

References setDefaultMask().

## removeRegion()

template<class T>

virtual void casacore::TempImage< T >::removeRegion | ( | const String & | name,
|  | RegionHandler::GroupType | = RegionHandler::Any,
|  | Bool | throwIfUnknown = True )

virtual

Remove a region/mask belonging to the image from the given group (which can be Any).

If a mask removed is the default mask, the image gets unmasked.
Optionally an exception is thrown if the region does not exist.

Reimplemented from casacore::ImageInterface< T >.

References casacore::RegionHandler::Any, name(), and casacore::True.

## reopen()

template<class T>

virtual void casacore::TempImage< T >::reopen | ( |  | ) |

virtual

If needed, reopen a temporarily closed TempLattice.

Reimplemented from casacore::LatticeBase.

## resize()

template<class T>

virtual void casacore::TempImage< T >::resize | ( | const TiledShape & | newShape | ) |

virtual

Function which changes the shape of the image (N.B.

the data is thrown away - the Image will be filled with nonsense afterwards)

Implements casacore::ImageInterface< T >.

## set()

template<class T>

virtual void casacore::TempImage< T >::set | ( | const T & | value | ) |

virtual

Function which sets all of the elements in the Lattice to a value.

Reimplemented from casacore::Lattice< T >.

References casacore::NewDelAllocator< T >::value.

## setCacheSizeFromPath()

template<class T>

virtual void casacore::TempImage< T >::setCacheSizeFromPath | ( | const IPosition & | sliceShape,
|  | const IPosition & | windowStart,
|  | const IPosition & | windowLength,
|  | const IPosition & | axisPath )

virtual

Set the cache size as to "fit" the indicated path.

Reimplemented from casacore::LatticeBase.

## setCacheSizeInTiles()

template<class T>

virtual void casacore::TempImage< T >::setCacheSizeInTiles | ( | uInt | howManyTiles | ) |

virtual

Set the actual cache size for this Array to be be big enough for the indicated number of tiles.

This cache is not shared with PagedArrays in other rows and is always clipped to be less than the maximum value set using the setMaximumCacheSize member function. tiles. Tiles are cached using a first in first out algorithm.

Reimplemented from casacore::LatticeBase.

## setDefaultMask()

template<class T>

virtual void casacore::TempImage< T >::setDefaultMask | ( | const String & | maskName | ) |

virtual

Set the default pixelmask to the mask with the given name (which has to exist in the "masks" group).

If the image table is writable, the setting is persistent by writing the name as a keyword. If the given regionName is the empty string, the default pixelmask is unset.

Reimplemented from casacore::ImageInterface< T >.

Referenced by removeMask().

## setMaximumCacheSize()

template<class T>

virtual void casacore::TempImage< T >::setMaximumCacheSize | ( | uInt | howManyPixels | ) |

virtual

Set the maximum (allowed) cache size as indicated.

Reimplemented from casacore::LatticeBase.

## shape()

template<class T>

virtual IPosition casacore::TempImage< T >::shape | ( |  | ) | const

virtual

Return the shape of the image.

Implements casacore::LatticeBase.

## showCacheStatistics()

template<class T>

virtual void casacore::TempImage< T >::showCacheStatistics | ( | ostream & | os | ) | const

virtual

Report on cache success.

Reimplemented from casacore::LatticeBase.

## tempClose()

template<class T>

virtual void casacore::TempImage< T >::tempClose | ( |  | ) |

virtual

Close the TempImage temporarily (if it is paged to disk).

Note that a possible mask is not closed. It'll be reopened automatically when needed or when reopen is called explicitly.

Reimplemented from casacore::LatticeBase.

## useMask()

template<class T>

virtual void casacore::TempImage< T >::useMask | ( | MaskSpecifier | = MaskSpecifier() | ) |

virtual

Use the mask as specified.

If a mask was already in use, it is replaced by the new one.

Reimplemented from casacore::ImageInterface< T >.

## Member Data Documentation

## mapPtr_p

template<class T>

TempLattice<T>* casacore::TempImage< T >::mapPtr_p

private

Definition at line 295 of file TempImage.h.

## maskPtr_p

template<class T>

Lattice<Bool>* casacore::TempImage< T >::maskPtr_p

private

Definition at line 296 of file TempImage.h.

The documentation for this class was generated from the following file:

- images/Images/TempImage.h